package com.lokesh.sse.controller;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.MediaType;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;
import reactor.core.publisher.Flux;
import reactor.kafka.receiver.KafkaReceiver;
import reactor.kafka.receiver.ReceiverRecord;

@RestController
@RequestMapping("/api/v2")
public class LiveMatchController {
    @Autowired
    KafkaReceiver<String,String> kafkaReceiver;


    @GetMapping(value = "/live-matches", produces = MediaType.TEXT_EVENT_STREAM_VALUE)
    Flux getLiveMatchEventsFlux(){
        Flux<ReceiverRecord<String,String>> kafkaFlux = kafkaReceiver.receive();
        return kafkaFlux.checkpoint("Messages are started being consumed")
                .log()
                .doOnNext(r -> r.receiverOffset().acknowledge())
                .map(ReceiverRecord::value).checkpoint("Messages are done consumed");
    }
}
